Attribute VB_Name = "modExtraitRAR"
Private Declare Function RAROpenArchive Lib "UnRAR.dll" (ByRef ArchiveData As RAROpenArchiveData) As Long
Private Declare Function RARCloseArchive Lib "UnRAR.dll" (ByVal hArcData As Long) As Long
Private Declare Function RARReadHeader Lib "UnRAR.dll" (ByVal hArcData As Long, ByRef HeaderData As RARHeaderData) As Long
Private Declare Function RARProcessFile Lib "UnRAR.dll" (ByVal hArcData As Long, ByVal Operation As Long, ByVal DestPath As String, ByVal DestName As String) As Long
Private Declare Sub RARSetPassword Lib "UnRAR.dll" (ByVal HandleToArchive As Long, ByVal Password As String)

Public Type RAROpenArchiveData
    ArcName As String
    OpenMode As Long
    OpenResult As Long
    CmtBuf As String
    CmtBufSize As Long
    CmtSize As Long
    CmtState As Long
End Type

Public Type RARHeaderData
    ArcName As String * 260
    FileName As String * 260
    Flags As Long
    PackSize As Long
    UnpSize As Long
    HostOS As Long
    FileCRC As Long
    FileTime As Long
    UnpVer As Long
    Method As Long
    FileAttr As Long
    CmtBuf As String
    CmtBufSize As Long
    CmtSize As Long
    CmtState As Long
End Type

Public Function ExtraitRAR(sFichier As String) As Boolean

   Dim OpArch As RAROpenArchiveData
   Dim HeadRAR As RARHeaderData
   Dim HandleRAR As Long
   Dim HeaderLine As Long
   Dim exeUNRAR As Long
   
   ExtraitRAR = False
   
   OpArch.ArcName = sFichier
   OpArch.CmtBuf = Space(16384)
   OpArch.CmtBufSize = 16384
   OpArch.OpenMode = 1
   
   HandleRAR = RAROpenArchive(OpArch)
   
   If OpArch.OpenResult <> 0 Then Exit Function
   

   
   ExtraitRAR = True
   
   
   Dim s As String
   
   HeaderLine = RARReadHeader(HandleRAR, HeadRAR)
   Do Until HeaderLine <> 0
   
        
        s = Left(HeadRAR.FileName, InStr(1, HeadRAR.FileName, Chr(0)) - 1)
        

        Form1.List1.AddItem s
        

      HeaderLine = RARReadHeader(HandleRAR, HeadRAR)
   Loop
   RARCloseArchive HandleRAR

End Function

